#ifndef _LINUX_ETECH_EE93C66_H
#define _LINUX_ETECH_EE93C66_H


#define EE93C66_EXIST 0x0001
#define EE93C66_SELEC 0x0002
#define EE93C66_BUSY	 0x0004
#define EE93C66_BUSY_BIT_POS 2
#define EE93C66_OFFL	 0x0008
#define EE93C66_NOPA  0x0010
#define EE93C66_ERR   0x0020
#define EE93C66_ABORT 0x0040
#define EE93C66_CAREFUL 0x0080 /* obsoleted -arca */
#define EE93C66_ABORTOPEN 0x0100

#define EE93C66_TRUST_IRQ_  0x0200 /* obsolete */
#define EE93C66_NO_REVERSE  0x0400 /* No reverse mode available. */
#define EE93C66_DATA_AVAIL  0x0800 /* Data is available. */


/* IOCTL numbers */


#define EE93C66_MAJOR 0x3c
#define EE93C66WEN 	0x3c01		/* write enable */
#define EE93C66WRALL	0x3c02		/* write all */
#define EE93C66WDS	0x3c03		/* write disable */
#define EE93C66REGISTER_ERASE 0x3c04	/* register erase */
#define EE93C66ERALL	0x3c05		/* erase all*/

#define EE93C66GPIO19	0x3c19
#define EE93C66GPIO22	0x3c20
#define EE93C66GPIO23	0x3c21
#define EE93C66SYSTEMREADY	0x3c22
#define EE93C66UPDATEFIRMWARESTART 0x3c23
#define EE93C66UPDATEFIRMWARESTOP 0x3c24

#ifdef __KERNEL__

/* Magic numbers for defining port-device mappings */

#define EE93C66_F(minor)	ee93c66_table[(minor)].flags		/* flags for busy, etc. */
#define EE93C66_CHAR(minor)	ee93c66_table[(minor)].chars		/* busy timeout */
#define EE93C66_TIME(minor)	ee93c66_table[(minor)].time		/* wait time */
#define EE93C66_WAIT(minor)	ee93c66_table[(minor)].wait		/* strobe wait */
#define EE93C66_IRQ(minor)	ee93c66_table[(minor)].dev->port->irq /* interrupt # */

#define EE93C66_BUFFER_SIZE PAGE_SIZE

#define EE93C66_BASE(x)	ee93c66_table[(x)].dev->port->base


struct ee93c66_addr_data {
	unsigned char reserved;
	unsigned char addr;
	unsigned short int data;
};

struct ee93c66_struct {
	struct pardevice *dev;
	unsigned long flags;
	unsigned int chars;
	unsigned int time;
	unsigned int wait;
	struct ee93c66_addr_data *ee93c66_buffer;
	wait_queue_head_t waitq;
	unsigned int last_error;
	struct semaphore port_mutex;
	wait_queue_head_t dataq;
	long timeout;
	unsigned int best_mode;
	unsigned int current_mode;
	unsigned long bits;
};

extern int ee93c66_init(void);

#endif /* __KERNEL__ */

#endif
