#ifndef _KB_GPIO_C5471_H
#define _KB_GPIO_C5471_H


#define KG_GPIO_C5471_DRV_EXIST 0x0001
#define KG_GPIO_C5471_DRV_SELEC 0x0002
#define KG_GPIO_C5471_DRV_BUSY	 0x0004
#define KG_GPIO_C5471_DRV_BUSY_BIT_POS 2
#define KG_GPIO_C5471_DRV_OFFL	 0x0008
#define KG_GPIO_C5471_DRV_NOPA  0x0010
#define KG_GPIO_C5471_DRV_ERR   0x0020
#define KG_GPIO_C5471_DRV_ABORT 0x0040
#define KG_GPIO_C5471_DRV_CAREFUL 0x0080 /* obsoleted -arca */
#define KG_GPIO_C5471_DRV_ABORTOPEN 0x0100

#define KG_GPIO_C5471_DRV_TRUST_IRQ_  0x0200 /* obsolete */
#define KG_GPIO_C5471_DRV_NO_REVERSE  0x0400 /* No reverse mode available. */
#define KG_GPIO_C5471_DRV_DATA_AVAIL  0x0800 /* Data is available. */


/* IOCTL numbers */


//#define KG_GPIO_C5471_DRV_MAJOR 0x3c

#ifdef __KERNEL__

/* Magic numbers for defining port-device mappings */

#define KG_GPIO_C5471_DRV_F(minor)	kb_gpio_c5471_table[(minor)].flags		/* flags for busy, etc. */
#define KG_GPIO_C5471_DRV_CHAR(minor)	kb_gpio_c5471_table[(minor)].chars		/* busy timeout */
#define KG_GPIO_C5471_DRV_TIME(minor)	kb_gpio_c5471_table[(minor)].time		/* wait time */
#define KG_GPIO_C5471_DRV_WAIT(minor)	kb_gpio_c5471_table[(minor)].wait		/* strobe wait */
#define KG_GPIO_C5471_DRV_IRQ(minor)	kb_gpio_c5471_table[(minor)].dev->port->irq /* interrupt # */

#define KG_GPIO_C5471_DRV_BUFFER_SIZE PAGE_SIZE

#define KG_GPIO_C5471_DRV_BASE(x)	kb_gpio_c5471_table[(x)].dev->port->base


struct kb_gpio_c5471_addr_data {
	unsigned char reserved;
	unsigned char addr;
	unsigned short int data;
};

struct  {
	struct pardevice *dev;
	unsigned long flags;
	unsigned int chars;
	unsigned int time;
	unsigned int wait;
	struct kb_gpio_c5471_addr_data *kb_gpio_c5471_buffer;
	wait_queue_head_t waitq;
	unsigned int last_error;
	struct semaphore port_mutex;
	wait_queue_head_t dataq;
	long timeout;
	unsigned int best_mode;
	unsigned int current_mode;
	unsigned long bits;
};

extern int kb_gpio_c5471_init(void);

#endif /* __KERNEL__ */


#endif
