/* Linux driver for TOSHIBA TC58V64AFT on WP3200 */

#ifndef __MTD_WVNAND_H__
#define __MTD_WVNAND_H__

#include <linux/mtd/mtd.h>

#define FCR			0x0
#define FCM			0x4
#define FAR			0x8
#define FDR			0xc

#define READ_WVNAND(adr, reg)      readl(((volatile u32)adr) + (reg))
#define WRITE_WVNAND(d, adr, reg)  writel(d, ((volatile u32)adr) + (reg))

#define CDSN_CTRL_FR_B 		0x80000000
#define CDSN_CTRL_ECC_IO 	0x20
#define CDSN_CTRL_FLASH_IO 	0x10
#define CDSN_CTRL_WP 		0x08
#define CDSN_CTRL_ALE 		0x04
#define CDSN_CTRL_CLE 		0x02
#define CDSN_CTRL_CE 		0x01
#define WVNAND_REGBASE		0x14000008
#endif 
