/* -*- linux-c -*-
 * sysctl_net_ether.c: sysctl interface to net Ethernet subsystem.
 *
 * Begun April 1, 1996, Mike Shaver.
 * Added /proc/sys/net/ether directory entry (empty =) ). [MS]
 */

#include <linux/mm.h>
#include <linux/sysctl.h>

static ctl_table speed_table[];
int sysctl_ethernet_speed_eth0=100;
int sysctl_ethernet_speed_eth1=100;
int sysctl_ethernet_speed_eth2=100;

ctl_table ether_table[] = {
	{NET_ETHER_SPEED, "speed", NULL, 0, 0555, speed_table},
	{0}
};

static ctl_table speed_table [] = {
	{NET_ETHER_SPEED_ETH0, "eth0", &sysctl_ethernet_speed_eth0 , sizeof(int), 0600, NULL, &proc_dointvec},
	{NET_ETHER_SPEED_ETH1, "eth1", &sysctl_ethernet_speed_eth1, sizeof(int), 0600, NULL, &proc_dointvec},
	{NET_ETHER_SPEED_ETH2, "eth2", &sysctl_ethernet_speed_eth2, sizeof(int), 0600, NULL, &proc_dointvec},
	{0}
};

