#include <stdio.h>
#include <stdlib.h>
#include "GUI_types.h"
#include "GUI_items.h"
#include "GUI_keys.h"

PGUI_SHORTCUT pShortCutList = NULL;

int CALLBACK keysEventHandler(int event, void *data)
{
  int iReturnValue = 0;

  switch (event) {
    case FUNC_ALL_Init:
      keysInit();
      break;
    case FUNC_KEYS_GetShortCutList:
      data = GetShortCutList();
      break;
    default: break;
  }
  return iReturnValue;
}

GUI_CALLBACK Init_keys()
{
  GUI_CALLBACK func = keysEventHandler;
  return func;
}

void EVENT_FUNC keysInit()
{
  // If users need to define the behavior for any undefined key,
  // add another AddShortCut() in InitUserDefinedKeys() with its key handler.
  // Then to implement the handler for the behaviors.
  // Otherwise, if users need to re-define the behavior for an existing key,
  // the implement of ShortCutHandler() needs to be modified.
  pShortCutList = AddShortCut(ShortCutHandler);
}

PGUI_SHORTCUT AddShortCut(GUI_CALLBACK func)
{
  PGUI_SHORTCUT pShortCut = malloc(sizeof(GUI_SHORTCUT));

  pShortCut->func = func;
  pShortCut->next = NULL;

  if (pShortCutList != NULL) {
    PGUI_SHORTCUT pTemp = pShortCutList;
    while (pTemp->next != NULL) {
      pTemp = pTemp->next;
    }
    pTemp->next = pShortCut;
  }

  return pShortCut;
}

PGUI_SHORTCUT EVENT_FUNC GetShortCutList()
{
  return pShortCutList;
}

#ifdef DIVISION_TEST
int CALLBACK ShortCutHandler(int key, void *data)
{
  int iReturnValue = 0;
  PGUI_MENU pMenu = GetCurrentMenu();

  switch (key) {
    case KEY_ENTER: pMenu->event_func(MENU_EVENT_ENTER, data); break;
    case KEY_UP: pMenu->event_func(MENU_EVENT_UP, data); break;
    case KEY_DOWN: pMenu->event_func(MENU_EVENT_DOWN, data); break;
    case KEY_LEFT: pMenu->event_func(MENU_EVENT_LEFT, data); break;
    case KEY_RIGHT: pMenu->event_func(MENU_EVENT_RIGHT, data); break;
    case KEY_CANCEL: pMenu->event_func(MENU_EVENT_CANCEL, data); break;
    default: break;
  }

  return iReturnValue;
}
#else
int CALLBACK ShortCutHandler(int key, void *data)
{
  int iReturnValue = 0, act_key = 0;

  if (IsMenuOpen()) {
    switch (key) {
      case KEY_ENTER:		act_key = ACTION_ENTER; break;
      case KEY_UP:		act_key = ACTION_UP; break;
      case KEY_DOWN:		act_key = ACTION_DOWN; break;
      case KEY_LEFT:		act_key = ACTION_LEFT; break;
      case KEY_RIGHT:		act_key = ACTION_RIGHT; break;
      case KEY_CANCEL:		act_key = ACTION_CANCEL; break;
      default: break;
    }
  } else {
    switch (key) {
      case KEY_PLAY:		act_key = ACTION_PLAY; break;
      case KEY_STOP:		act_key = ACTION_STOP; break;
      case KEY_PAUSE:		act_key = ACTION_PAUSE; break;
      case KEY_RECORD_PLAY:	act_key = ACTION_RECORD_PLAY; break;
      case KEY_SLOWER:		act_key = ACTION_SLOWER; break;
      case KEY_FASTER:		act_key = ACTION_FASTER; break;
      case KEY_REVFASTER:	act_key = ACTION_REVFASTER; break;
      case KEY_CHNL_UP:		act_key = ACTION_CHNL_UP; break;
      case KEY_CHNL_DN:		act_key = ACTION_CHNL_DN; break;
      case KEY_FILE_HEAD:	act_key = ACTION_FILE_HEAD; break;
      case KEY_FILE_TAIL:	act_key = ACTION_FILE_TAIL; break;
      case KEY_SHOW:		act_key = ACTION_SHOW; break;
      case KEY_AUTO_SCAN:	act_key = ACTION_AUTO_SCAN; break;
      case KEY_INPUT:		act_key = ACTION_INPUT; break;
      case KEY_MODE_TIMESHIFT:	break;
      default: break;
    }
  }

  if (act_key) iReturnValue = pActionHandler(act_key, data);

  return iReturnValue;
}
#endif
