#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "nano-X.h"
#include "Util.h"
#include "TimeShift.h"
#include "Globals.h"
#include "GUI_definition.h"
#include "GUI_types.h"
#include "GUI_items.h"
#include "GUI_keys.h"
#include "GUI_fileview.h"

#include <termios.h>
#include <fcntl.h>
#include <unistd.h>
struct termios terminal_control_init()
{
  struct termios new, old;
  long Mode;

  tcgetattr(STDIN_FILENO, &old);
  new = old;
  new.c_iflag &= ~(BRKINT | ICRNL);
  new.c_lflag &= ~(ECHO | ICANON | ISIG);
  tcsetattr(STDIN_FILENO, TCSANOW, &new);
  Mode = fcntl(STDIN_FILENO,F_GETFL);
  Mode |= O_NDELAY;
  fcntl(STDIN_FILENO, F_SETFL, Mode);
  return old;
}

const char strConfigFile_CSTrunc[] = "CaptureSetting";
const char strConfigFile_quality[] = "Quality";
const char strConfigFile_mpegtype[] = "MpegType";
const char* strConfigFile_CScustom[] = {"MPEG1", "VCD", "SVCD", "MPEG2", "DVD"};
int FileAmount = 0;

PGUI_MENU pMenuFMFileView = NULL;

PGUI_MENU Do_Job(int level)
{
  int Max,Dir=0;
  PGUI_MENU pMenu = GetCurrentMenu();
  PGUI_MENU pTemp = NULL;
      
  Max = pMenuFMFileView->child->max;
  switch(level)
  {     
    case 1: printf("*** Play ***\n");
            pTemp = pMenuFMFileView;
            break;
    case 2: printf("*** Delete ***\n");
            pMenu->parent->state = STATE_DISABLE;
            pTemp = pMenu->parent;
            do{
              if(pTemp->next == NULL)
              {
                Dir = 1;
                pTemp = pMenu->parent;
              } 
              pTemp = Dir?pTemp->prev:pTemp->next;
              Max--;
            }while(pTemp->state==STATE_DISABLE && Max>1);
            pTemp = (Max==1)?pMenuFMFileView:pTemp;
            break;
    case 3: printf("*** Burn ***\n");
            pTemp = pMenu->parent;
            break;
    default: pTemp = pMenu; break;		
  }   
  return pTemp;
} 

int EventHandler(int event, void *data)
{
  int search,iReturnValue = 0;
  static int level = 0;	
  PGUI_MENU pMenu = GetCurrentMenu();
  PGUI_MENU pTemp = NULL;

  switch (event) {
    case MENU_EVENT_INIT:
      if(pMenu == pMenuFMFileView) 
	LoadSetting();
      break;
    case MENU_EVENT_ENTER:
      fprintf(stdout, " press enter\n");
      if(pMenu->child != NULL)
      {
	if(pMenu == pMenuFMFileView)
	{
	  if(pMenu->child->max)
	  {
	    pTemp = pMenu->child->child;
	    while(pTemp->state == STATE_DISABLE)
	    {
	      if(pTemp->next != NULL)
	        pTemp = pTemp->next;	
	      else
	      {	
		pTemp = pMenu->child;
		printf("***** NO FILE *****\n");
	      }
	    }
	    //printf("%d Menu=%p prev=%p next=%p state=%x\n",__LINE__,pTemp,pTemp->prev,
	    //		pTemp->next,pTemp->state);
	    SetCurrentMenu(pTemp);
	  }
	  else
   	  {
	    //printf("%d Menu=%p state=%x\n",__LINE__,pMenu->child,pMenu->child->state);
	    SetCurrentMenu(pMenu->child);	 
	    printf("*** NO FILE ***\n");
	  }
	}
	else
	{
	  level = 1;
	  //printf("%d Menu=%p state=%x\n",__LINE__,pMenu->child,pMenu->child->state);
	  SetCurrentMenu(pMenu->child);  
	}
      }
      else if(pMenu->parent != NULL) 
      { 
 	pTemp = Do_Job(level);
	level = 0;
	//printf("%d Menu=%p parent=%p prev=%p next=%p state=%x\n",__LINE__,pTemp,pTemp->parent
	//	   ,pTemp->prev,pTemp->next,pTemp->state);
	SetCurrentMenu(pTemp);
      }
      break;
    case MENU_EVENT_CANCEL:
      fprintf(stdout, " press cancel\n");
      if(pMenu->parent != NULL) 
      {
	if(pMenu->parent == pMenuFMFileView->child)
	{
	  //printf("%d Menu=%p prev=%p next=%p state=%x\n",__LINE__,pMenuFMFileView,
	  //	pMenuFMFileView->prev,pMenuFMFileView->next,pMenuFMFileView->state);
	  SetCurrentMenu(pMenuFMFileView);
	}
	else
	{
	  //printf("%d Menu=%p state=%x\n",__LINE__,pMenu->parent,
	  //		pMenu->parent->state);
	  level = 0;
	  SetCurrentMenu(pMenu->parent);
	}
      }	
      else if(pMenu == pMenuFMFileView)
      {	
	printf("***** SaveSetting *****\n");
      } 
      break;
    case MENU_EVENT_UP:
      fprintf(stdout, " press up\n");
      if((pMenu->parent != NULL) && (pMenu->parent->max > 1))
      {	
	pTemp = pMenu;
	while(pTemp->prev != NULL)
	{
	  if(pTemp->prev->state == STATE_DISABLE)
	  {
	    search = 1;
	    pTemp = pTemp->prev;
	  }
	  else
	  {
	    search = 0; 
	    pTemp = pTemp->prev;
	    break;
	  }
	}
	pTemp = search?pMenu:pTemp;
	if(pMenu->child == NULL)
	  level=(level>1)?level-1:level;
	//printf("%d Menu=%p prev=%p next=%p state=%x\n",__LINE__,pTemp,pTemp->prev,pTemp->next,
	//	pTemp->state);
	SetCurrentMenu(pTemp);	
      }	
      break;
    case MENU_EVENT_DOWN:
      fprintf(stdout, " press down\n");
      if((pMenu->parent != NULL) && (pMenu->parent->max > 1))
      {	
	pTemp = pMenu;
	while(pTemp->next != NULL)
	{
	  if(pTemp->next->state == STATE_DISABLE)
	  {
	    search = 1;
	    pTemp = pTemp->next;
	  }
	  else
	  {
	    search = 0;
	    pTemp = pTemp->next;
	    break;	
	  }
	}
	pTemp = search?pMenu:pTemp;
	if(pMenu->child == NULL)
	  level=(level<3)?level+1:level;
	//printf("%d Menu=%p prev=%p next=%p state=%x\n",__LINE__,pTemp,pTemp->prev,pTemp->next,
	//	pTemp->state);
	SetCurrentMenu(pTemp);
      }	
      break;
    default: break;
  }
  if (event) {
    PGUI_MENU pCurrentMenu = NULL;
    if ((pCurrentMenu = GetCurrentMenu()) != NULL)
      printf("name = %s, max = %d\n", pCurrentMenu->name, pCurrentMenu->max);
    else printf("current menu is NULL\n");
  }

  return iReturnValue;
}

NEW_MENUITEM(gmFMFileView, txtFMFileView, STATE_ENABLE, EventHandler);
NEW_MENUITEM(gmFVTitle, txtFVTitle, STATE_ENABLE, EventHandler);
NEW_MENUITEM(gmFVList, txtFVList, STATE_ENABLE, EventHandler);
NEW_MENUITEM(gmFVPlay, txtFVPlay, STATE_ENABLE, EventHandler);
NEW_MENUITEM(gmFVDel, txtFVDel, STATE_ENABLE, EventHandler);
NEW_MENUITEM(gmFVBurn, txtFVBurn, STATE_ENABLE, EventHandler);

#ifdef DIVISION_TEST
GUI_CALLBACK pCallKeys = NULL;
int main()
{
  int i,NextKey;
  PGUI_SHORTCUT pList = NULL;
  struct termios default_termios = terminal_control_init();
  PGUI_MENU pMenuTemp = NULL;
  PGUI_MENU pMenuFVTitle = NULL;
  PGUI_MENU pMenuPlay = NULL;
  PGUI_MENU pMenuBurn = NULL;

  pCallKeys = Init_keys();
  pCallKeys(FUNC_ALL_Init, NULL);

  pMenuFMFileView = AddMenu(NULL, gmFMFileView);
  pMenuFVTitle = AddMenu(pMenuFMFileView, gmFVTitle);
 	
  for(i=1;i<=FileAmount;i++)
  {
    pMenuTemp = AddMenu(pMenuFVTitle, gmFVList);
    pMenuPlay = AddMenu(pMenuTemp, gmFVPlay);
    		AddMenu(pMenuTemp, gmFVDel);
    pMenuBurn = AddMenu(pMenuTemp, gmFVBurn);
//printf("%d %p next=%p child=%p max=%d\n",i,pMenuTemp,pMenuTemp->next,pMenuTemp->child,pMenuTemp->max);
//printf("  play=%p prev=%p next=%p\n",pMenuPlay,pMenuPlay->prev,pMenuPlay->next);
//printf("  burn=%p prev=%p next=%p\n",pMenuBurn,pMenuBurn->prev,pMenuBurn->next);
    pMenuPlay->prev = NULL;
    pMenuBurn->next = NULL;	 
  }	
 
  if(pMenuFVTitle->child != NULL)
  { 
    pMenuFVTitle->child->prev->next = NULL;	
    pMenuFVTitle->child->prev = NULL;	
  }

  SetCurrentMenu(pMenuFMFileView);

  pList = GetShortCutList();
  while ((NextKey = getchar()) != 81) {
    if (pList != NULL) pList->func(NextKey, NULL);
  }
  tcsetattr(STDIN_FILENO, TCSANOW, &default_termios);
  return 0;
}
#endif

void LoadSetting()
{
  DWORD state;

  if ((state = LoadSettingFromFile()) != LOADFILE_SUCCESS)
    LoadDefaultSetting(state);
}

DWORD LoadSettingFromFile()
{
  char name[20], value[5], trunc[20];
  int result, i;
  DWORD state = LOADFILE_SUCCESS;
  FILE* file;

#ifdef DARYL_TEST
  fprintf(stdout, "Daryl -- ******** Load capture setting file. ********\n");
#endif
  if ((file = fopen(fileCaptureConfig, "r")) == NULL) {
    fprintf(stderr, "Error! -- the file \"%s\" does not exist.\n", fileCaptureConfig);
    state = LOADFILE_FAIL_NOFILE;
    return state;
  }
  
  // Search the capture setting block.
  rewind(file);
  do {
    result = fscanf(file, "%s\n", trunc);
  } while (strcmp(trunc, strConfigFile_CSTrunc) && (result != EOF));

  if (result == EOF) {
    fprintf(stderr, "Error! -- cannot find capture setting trunc.\n");
    return (LOADFILE_FAIL_QUALITY | LOADFILE_FAIL_MPEGTYPE |
	    LOADFILE_FAIL_CSCUSTOM);
  }

  // read quality
  if (((result = fscanf(file, "%s%s\n", name, value)) != EOF) &&
      !strcmp(name, strConfigFile_quality)) {
    config.cs.mode = atoi(value);
    if ((config.cs.mode > CAPTURE_CUSTOM) || (config.cs.mode < CAPTURE_SP)) {
      fprintf(stderr, "Error! -- incorrect quality value (%d).\n", config.cs.mode);
      state |= LOADFILE_FAIL_QUALITY;
    }
#ifdef DARYL_TEST
    fprintf(stdout, "Daryl -- load quality value ..... %d\n", config.cs.mode);
#endif
  } else {
    fprintf(stderr, "Error! -- load quality value error .... %d\n", result);
    state |= LOADFILE_FAIL_QUALITY;
  }
  // read mpeg type
  if (((result = fscanf(file, "%s%s\n", name, value)) != EOF) &&
      !strcmp(name, strConfigFile_mpegtype)) {
    config.cs.select = atoi(value);
    if ((config.cs.select > CAPTURE_DVD) || (config.cs.select < CAPTURE_SVCD)) {
      fprintf(stderr, "Error! -- incorrect mpeg type (%d).\n", config.cs.select);
      state |= LOADFILE_FAIL_MPEGTYPE;
    }
#ifdef DARYL_TEST
    fprintf(stdout, "Daryl -- load mpeg type ..... %d\n", config.cs.select);
#endif
  } else {
    fprintf(stderr, "Error! -- load mpeg type error .... %d\n", result);
    state |= LOADFILE_FAIL_MPEGTYPE;
  }
  // read setting for each mpeg type
  for (i = 0; i < 5; i++) {
    char custom[4][5];
    if (((result = fscanf(file, "%s%s%s%s%s\n", name, custom[0], custom[1],
		          custom[2], custom[3])) != EOF) &&
        !strcmp(name, strConfigFile_CScustom[i])) {
      config.cs.set[i].vbr = atoi(custom[0]);
      config.cs.set[i].abr = atoi(custom[1]);
      config.cs.set[i].asr = atoi(custom[2]);
      config.cs.set[i].type = atoi(custom[3]);
      if ((config.cs.set[i].vbr > 3) || (config.cs.set[i].vbr < 1)) {
        fprintf(stderr, "Error! -- incorrect video bit rate (%d).\n", config.cs.set[i].vbr);
	state |= LOADFILE_FAIL_CSCUSTOM; break;
      }
      if ((config.cs.set[i].abr > 3) || (config.cs.set[i].abr < 1)) {
        fprintf(stderr, "Error! -- incorrect audio bit rate (%d).\n", config.cs.set[i].abr);
	state |= LOADFILE_FAIL_CSCUSTOM; break;
      }
      if ((config.cs.set[i].asr > 2) || (config.cs.set[i].asr < 1)) {
        fprintf(stderr, "Error! -- incorrect audio sample rate (%d).\n", config.cs.set[i].asr);
	state |= LOADFILE_FAIL_CSCUSTOM; break;
      }
      if ((config.cs.set[i].type > 2) || (config.cs.set[i].type < 1)) {
        fprintf(stderr, "Error! -- incorrect record type (%d).\n", config.cs.set[i].type);
	state |= LOADFILE_FAIL_CSCUSTOM; break;
      }
#ifdef DARYL_TEST
      fprintf(stdout, "Daryl -- load vbr(%d), abr(%d), asr(%d) and type(%d) for %d\n",
	      config.cs.set[i].vbr, config.cs.set[i].abr, config.cs.set[i].asr,
	      config.cs.set[i].type, i);
#endif
    } else {
      fprintf(stderr, "Error! -- load setting for %d error.\n", i);
      state |= LOADFILE_FAIL_CSCUSTOM; break;
    }
  }
  return state;
}

void LoadDefaultSetting(DWORD state)
{
}

void SaveSetting()
{
  if (!SaveSettingToFile()) {
    fprintf(stderr, "Error! -- save capture setting error.\n");
  }
}

GR_BOOL SaveSettingToFile()
{
  char value[5];
  int i;
  FILE* file;

#ifdef DARYL_DEBUG
  fprintf(stdout, "Daryl -- ******** Save setting to file. ********\n");
#endif
  remove(fileCaptureConfig);
  if ((file = fopen(fileCaptureConfig, "w+")) == NULL) {
    fprintf(stderr, "Error! -- error to open file \"%s\".\n", fileCaptureConfig);
    return GR_FALSE;
  }

  // write capture setting trunc
  if (fprintf(file, "%s\n", strConfigFile_CSTrunc) == -1) {
    fprintf(stderr, "Error! -- cannot write capture setting.\n");
    return GR_FALSE;
  }

  // write quality
  gcvt(config.cs.mode, 1, value);
  if (fprintf(file, "%s %s\n", strConfigFile_quality, value) == -1) {
    fprintf(stderr, "Error! -- save quality value error\n");
    return GR_FALSE;
  }

  // write mpeg type
  gcvt(config.cs.select, 1, value);
  if (fprintf(file, "%s %s\n", strConfigFile_mpegtype, value) == -1) {
    fprintf(stderr, "Error! -- save mpeg type error\n");
    return GR_FALSE;
  }

  // write setting for each mpeg type
  for (i = 0; i < 5; i++) {
    char custom[4][5];
    gcvt(config.cs.set[i].vbr, 1, custom[0]);
    gcvt(config.cs.set[i].abr, 1, custom[1]);
    gcvt(config.cs.set[i].asr, 1, custom[2]);
    gcvt(config.cs.set[i].type, 1, custom[3]);
    if (fprintf(file, "%s %s %s %s %s\n", strConfigFile_CScustom[i],
	        custom[0], custom[1], custom[2], custom[3]) == -1) {
      fprintf(stderr, "Error! -- save setting for mpeg type %d error.\n", i);
      return GR_FALSE;
    }
  }
  return GR_TRUE;
}
