#include "GUI_types.h"
#include "GUI_reservation.h"

SCHEDULELIST pListReservation;
int listReservationAmount;
int listReservationIndex;

void InitReservationItem()
{
   pListReservation=NULL;
   listReservationAmount = 0;
}

RLITEM *AllocateReservationItem()
{
   RLITEM *item1;
   item1 = (RLITEM *)malloc(sizeof(RLITEM));
   item1->pPrev = item1;
   item1->pNext = item1;
   return item1;
}

RLITEM *AddReservationItem(RLITEM *pItem)
{
   RLITEM *item1;
   if (pItem != NULL)
   {
      if (pListReservation == NULL)
      {
         listReservationAmount = 1;
         pListReservation = pItem;
      }
      else
      {
         item1 = pListReservation->pPrev;
         item1->pNext = pItem;
         pListReservation->pPrev = pItem;
         pItem->pPrev = item1;
         pItem->pNext = pListReservation;
         listReservationAmount++;
         return pItem;
      }
   }
   return NULL;
}
RLITEM *RemoveReservationItem(RLITEM *pItem)
{
   RLITEM *pItem1,*pItem2;
   if (pItem)
   {
      pItem1 = pItem->pNext;
      if (pListReservation == pItem)
         pListReservation = pItem1;
      pItem2 = pItem->pPrev;
      pItem1->pPrev = pItem2;
      pItem2->pNext = pItem1;
      listReservationAmount--;
      if (listReservationAmount==0)
         pListReservation = NULL;
      return pItem;
   }
   return NULL;
}
RLITEM *GetReservationItem(int index)
{
   int i;
   RLITEM *pItem1=NULL;
   if (index<0)
      return NULL;
   if (index<listReservationAmount)
   {
      pItem1 = pListReservation;
      for(i=0;i<index;i++)
         pItem1 = pItem1->pNext;
   }
   return pItem1;
}
int GetReservationItemCount()
{
   return listReservationAmount;
}
