#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "nano-X.h"
#include "Util.h"
#include "TimeShift.h"
#include "Globals.h"
#include "GUI_definition.h"
#include "GUI_types.h"
#include "GUI_items.h"
#include "GUI_keys.h"
#include "GUI_reservation.h"
#include "GUI_reservation_del.h"
#include <termios.h>
#include <fcntl.h>
#include <unistd.h>

int DelAllReservationEventHandler(int event, void *data);
PGUI_MENU pMenuDelAllReservation = NULL;
NEW_MENUITEM(gmDelAllReservation, txtDelReservation, STATE_ENABLE, 0, DelAllReservationEventHandler);

struct termios terminal_control_init()
{
  struct termios new, old;
  long Mode;

  tcgetattr(STDIN_FILENO, &old);
  new = old;
  new.c_iflag &= ~(BRKINT | ICRNL);
  new.c_lflag &= ~(ECHO | ICANON | ISIG);
  tcsetattr(STDIN_FILENO, TCSANOW, &new);
  Mode = fcntl(STDIN_FILENO,F_GETFL);
  Mode |= O_NDELAY;
  fcntl(STDIN_FILENO, F_SETFL, Mode);
  return old;
}

void dump()
{
   RLITEM *pItem1=NULL,*pItem2=NULL;
   int i=0;
   pItem1 = GetReservationItem(0);
   while (i<GetReservationItemCount())
   { 
      pItem2=pItem1;
      printf("%s:%d channel=%d \n",__FILE__,__LINE__,pItem1->channel);
      pItem1=pItem1->pNext;
      i++;
   }
   i=0;
   while(i<GetReservationItemCount())
   {
      printf("%s:%d channel=%d \n",__FILE__,__LINE__,pItem2->channel);
      pItem2=pItem2->pPrev;
      i++;
   }
}


int DelAllReservationEventHandler(int event, void *data)
{
  const int MaxItems = 2;
  int iReturnValue = 0;
//index = 0 : No to delete
//index = 1 : Yes to delete
  static int index;
  int i;
  PGUI_MENU pMenu = GetCurrentMenu();

  switch (event) {
    case MENU_EVENT_INIT:
      break;
    case MENU_EVENT_OPEN:
      fprintf(stdout,"Show Yes/No Dialog\n");
      index = 0;
      fprintf(stdout,"No Delete\n");
      break;
    case MENU_EVENT_FINISH:
      break;
    case MENU_EVENT_ENTER:
      if (index==1)
      {
         i = GetReservationItemCount();
         while(i>0)
         {
            free(GetReservationItem(0));
            i--;
         }  
      }
    case MENU_EVENT_CANCEL:
      fprintf(stdout, "test -- press cancel\n");
      if (pMenu->parent != NULL) SetCurrentMenu(pMenu->parent);
      else fprintf(stdout, "test -- parent is NULL\n");
      break;
    case MENU_EVENT_UP:
      break;
    case MENU_EVENT_DOWN:
      break;
    case MENU_EVENT_LEFT:
      if (index ==( MaxItems-1))
         index = -1;
      index++;
      switch (index)
      {
         case 0:
           fprintf(stdout,"No Delete\n");
           break;
         case 1:
           fprintf(stdout,"Yes Delete\n");
           break;
      }
      break;
    case MENU_EVENT_RIGHT:
      if(index == 0)
         index = MaxItems;
      index--;
      switch (index)
      {
         case 0:
           fprintf(stdout,"No Delete\n");
           break;
         case 1:
           fprintf(stdout,"Yes Delete\n");
           break;
      }
      break;
    default: break;
  }
  return iReturnValue;
}



//NEW_MENUITEM(gm, txt, STATE_ENABLE, EventHandler);
#ifdef DIVISION_TEST
GUI_CALLBACK pCallKeys = NULL;
//GUI_CALLBACK pCallItems = NULL;
int main()
{
  int NextKey;
  PGUI_SHORTCUT pList = NULL;
  struct termios default_termios = terminal_control_init();
  PGUI_MENU pMenuTemp = NULL;

  pCallKeys = Init_keys();
  pCallKeys(FUNC_ALL_Init, NULL);

  pMenuDelAllReservation = AddMenu(NULL, gmDelAllReservation);
  pMenuDelAllReservation->event_func(MENU_EVENT_OPEN,pMenuDelAllReservation->data);

  SetCurrentMenu(pMenuDelAllReservation);
  pList = GetShortCutList();
  while ((NextKey = getchar()) != 81) {
    if (pList != NULL) pList->func(NextKey, NULL);
  }
  tcsetattr(STDIN_FILENO, TCSANOW, &default_termios);
  return 0;
}
#endif

