#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "nano-X.h"
#include "Util.h"
#include "TimeShift.h"
#include "Globals.h"
#include "GUI_definition.h"
#include "GUI_types.h"
#include "GUI_items.h"
#include "GUI_keys.h"
#include "GUI_reservation.h"
#include "GUI_reservation_new.h"
#include "GUI_reservation_list.h"
#include <termios.h>
#include <fcntl.h>
#include <unistd.h>

int ListReservationEventHandler(int event, void *data);
int ListResPopEventHandler(int event, void *data);

PGUI_MENU pMenuListReservation = NULL;
NEW_MENUITEM(gmListReservation, txtListReservation, STATE_ENABLE, 0, ListReservationEventHandler);
NEW_MENUITEM(gmListResPopMenu, "", STATE_ENABLE, 0, ListResPopEventHandler);
int listReservationIndex;

struct termios terminal_control_init()
{
  struct termios new, old;
  long Mode;

  tcgetattr(STDIN_FILENO, &old);
  new = old;
  new.c_iflag &= ~(BRKINT | ICRNL);
  new.c_lflag &= ~(ECHO | ICANON | ISIG);
  tcsetattr(STDIN_FILENO, TCSANOW, &new);
  Mode = fcntl(STDIN_FILENO,F_GETFL);
  Mode |= O_NDELAY;
  fcntl(STDIN_FILENO, F_SETFL, Mode);
  return old;
}

void ListResrvationLoadSetting()
{
#ifdef DIVISION_TEST
  int i;
  RLITEM* pItem;
  RLITEM* pLast;
  for (i=0;i<5;i++)
  {
     pItem = AllocateReservationItem();
     pItem->input = 1;
     pItem->channel = i;
     AddReservationItem(pItem);
  }
#endif
fprintf(stdout,"%s:%d you should override the function\n",__FILE__,__LINE__);
}
#define ENTRIES_PER_PAGE 8
void ListReservation_DrawBG()
{
}


void ListReservation_DrawLightBar(int index)
{
   int i;
   RLITEM *pItem;
   pItem = GetReservationItem(index);
   fprintf(stdout,"%s: item channel=%d \n",__FUNCTION__,pItem->channel);
}
void ListReservation_DrawItem(int index)
{
   int i;
   RLITEM *pItem;
   pItem = GetReservationItem(index);
   fprintf(stdout,"%s: item channel=%d \n",__FUNCTION__,pItem->channel);
}
void ListReservation_DrawItems(int begin,int num,int max)
{
   int i;
   RLITEM *pItem;
   if (begin > max)
      return;
   num = ((max-begin)>num) ? num:(max-begin);
   
   for (i=begin; i<begin+num; i++)
   {
      pItem = GetReservationItem(i);
      fprintf(stdout,"item channel=%d \n",pItem->channel);
   }
}
void dump()
{
   RLITEM *pItem1=NULL,*pItem2=NULL;
   int i=0;
   while (i<GetReservationItemCount())
   { 
      pItem1 = GetReservationItem(i);
      pItem2=pItem1;
      printf("%s:%d channel=%d \n",__FILE__,__LINE__,pItem1->channel);
      i++;
   }
   i=0;
   while(i<GetReservationItemCount())
   {
      printf("%s:%d channel=%d \n",__FILE__,__LINE__,pItem2->channel);
      pItem2=pItem2->pPrev;
      i++;
   }
}

void ListResPop_DoJob(int index)
{
   int i;
   RLITEM *pItem1,*pItem2,*pItem3;
   int temp,temp1;
   switch(index)
   {
      case 0:   // modify reservation
//        NewReservationModifyItem(listReservationIndex);
        
        break;
      case 1:   // delete reservation
        pItem1 = GetReservationItem(listReservationIndex);
        RemoveReservationItem(pItem1);
        free(pItem1);

//        dump();
	printf("listReservationIndex=%d \n",listReservationIndex);
        if (listReservationIndex==GetReservationItemCount())
        {
           listReservationIndex--;
        }
        if (GetReservationItemCount()>0)
        {
           temp = listReservationIndex / ENTRIES_PER_PAGE;
           temp1 = listReservationIndex % ENTRIES_PER_PAGE;
           ListReservation_DrawItems(listReservationIndex, ENTRIES_PER_PAGE-temp1 , GetReservationItemCount());
           ListReservation_DrawLightBar(listReservationIndex);
        }
        SetCurrentMenu(pMenuListReservation);
        break;
   }
}
void ListResPop_DrawLightBar(int index)
{
      if (index==0)
           fprintf(stdout, "%s:modify\n",__FUNCTION__);
      else
           fprintf(stdout, "%s:delet\n",__FUNCTION__);
}
void ListResPop_DrawItem(int index)
{
      if (index==0)
           fprintf(stdout, "%s:modify\n",__FUNCTION__);
      else
           fprintf(stdout, "%s:delect\n",__FUNCTION__);
}

int ListResPopEventHandler(int event, void *data)
{
  int iReturnValue = 0;
  const int MaxItems = 2;
  static int index;
  PGUI_MENU pMenu = GetCurrentMenu();
  switch (event) {
    case MENU_EVENT_INIT:
      break;
    case MENU_EVENT_OPEN:
      index = 0 ;
      ListResPop_DrawLightBar(0);
      ListResPop_DrawItem(1);
      break;
    case MENU_EVENT_FINISH:
      break;
    case MENU_EVENT_ENTER:
      ListResPop_DoJob(index); 
      break;
    case MENU_EVENT_CANCEL:
      break;
    case MENU_EVENT_UP:
      if (index>0)
      {
         ListResPop_DrawItem(index);
         index--;
         ListResPop_DrawLightBar(index);
      }
      break;
    case MENU_EVENT_DOWN:
      if (index<MaxItems-1)
      {
         ListResPop_DrawItem(index);
         index++;
         ListResPop_DrawLightBar(index);
      }
      break;
    case MENU_EVENT_LEFT:
      break;
    case MENU_EVENT_RIGHT:
      break;
    default: break;
  }
  return iReturnValue;

}

int ListReservationEventHandler(int event, void *data)
{
  int i,iReturnValue = 0;
  PGUI_MENU pMenu = GetCurrentMenu();

  switch (event) {
    case MENU_EVENT_INIT:
      InitReservationItem();
      ListResrvationLoadSetting();
      break;
    case MENU_EVENT_OPEN:
      listReservationIndex = 0;
      ListReservation_DrawBG();
      if (GetReservationItemCount() > 0)
      {
          ListReservation_DrawItems(listReservationIndex, ENTRIES_PER_PAGE , GetReservationItemCount());
          ListReservation_DrawLightBar(listReservationIndex);
      }
      break;
    case MENU_EVENT_FINISH:
      break;
    case MENU_EVENT_ENTER:
      if (GetReservationItemCount() > 0)
      {
         SetCurrentMenu(pMenu->child);
         pMenu->child->event_func(MENU_EVENT_OPEN,pMenu->child->data);
      }
      break;
    case MENU_EVENT_CANCEL:
      fprintf(stdout, "test -- press cancel\n");
      if (pMenu->parent != NULL) SetCurrentMenu(pMenu->parent);
      else fprintf(stdout, "test -- parent is NULL\n");
      break;
    case MENU_EVENT_UP:
      if (GetReservationItemCount() > 0)
      {
	 if (listReservationIndex>0)
         {
           if ((listReservationIndex % ENTRIES_PER_PAGE) == 0)
              ListReservation_DrawItems(listReservationIndex-ENTRIES_PER_PAGE, ENTRIES_PER_PAGE, GetReservationItemCount() );
           else
	      ListReservation_DrawItem(listReservationIndex);
           listReservationIndex--; 
           ListReservation_DrawLightBar(listReservationIndex);
         }
      }
      break;
    case MENU_EVENT_DOWN:
      if (GetReservationItemCount() > 0 && listReservationIndex<(GetReservationItemCount()-1))
      {
	 if (((listReservationIndex+1) % ENTRIES_PER_PAGE)==0)
            ListReservation_DrawItems(listReservationIndex+1, ENTRIES_PER_PAGE, GetReservationItemCount());
         else
	   ListReservation_DrawItem(listReservationIndex);
         listReservationIndex++;
         ListReservation_DrawLightBar(listReservationIndex);
      }
   
      break;
    case MENU_EVENT_LEFT:
      fprintf(stdout, "test -- press left -- do nothing\n");
      break;
    case MENU_EVENT_RIGHT:
      fprintf(stdout, "test -- press right -- do nothing\n");
      break;
    default: break;
  }
  return iReturnValue;
}



//NEW_MENUITEM(gm, txt, STATE_ENABLE, EventHandler);
#ifdef DIVISION_TEST
GUI_CALLBACK pCallKeys = NULL;
//GUI_CALLBACK pCallItems = NULL;
int main()
{
  int NextKey;
  PGUI_SHORTCUT pList = NULL;
  struct termios default_termios = terminal_control_init();
  PGUI_MENU pMenuTemp = NULL;

  pCallKeys = Init_keys();
  pCallKeys(FUNC_ALL_Init, NULL);

  pMenuListReservation = AddMenu(NULL, gmListReservation);
  AddMenu(pMenuListReservation,gmListResPopMenu);
  
  SetCurrentMenu(pMenuListReservation);
  pMenuListReservation->event_func(MENU_EVENT_INIT,pMenuListReservation->data);
  pMenuListReservation->event_func(MENU_EVENT_OPEN,pMenuListReservation->data);
  pList = GetShortCutList();
  while ((NextKey = getchar()) != 81) {
    if (pList != NULL) pList->func(NextKey, NULL);
  }
  tcsetattr(STDIN_FILENO, TCSANOW, &default_termios);
  return 0;
}
#endif

